/*
 * file:   man1d_list.h
 * author: Hinke Osinga - University of Bristol
 * date:   November 1997
 */

#ifndef LIST_H
#define LIST_H

#include "memory.h"

#define    TRAJ_MAX   30000


typedef struct list_item{
  double            *data;         /* point in fundamental domain */
  double            *inverse;      /* inverse of data */
  struct list_item  *next, *prev;  /* next and prev points in fund dom */
  struct list_item  *invleft;      /* left closest point to inverse */
} LIST_ITEM, *List;

typedef struct oned_man{
  int     size, v_dim;
  double  arclength;
  List    head;
  List    tail;
} ONED_MAN;

/* man1d_list.c */
int  mfld_load(ONED_MAN *mfld, int dim);
void mfld_release(ONED_MAN *mfld);
int  add_to_mfld(ONED_MAN *mfld, double *p, double *finvp, List invleft);
void empty_mfld(ONED_MAN *mfld);
void mfld_save(ONED_MAN *mfld, memory m, double *params, int color, 
	       int symbol, int mfld_type);

#endif
