/*
The DsTool program is the property of:
 
                             Cornell University 
                        Center of Applied Mathematics 
                              Ithaca, NY 14853
                      dstool_bugs@macomb.tn.cornell.edu
 
and may be used, modified and distributed freely, subject to the following
restrictions:
 
       Any product which incorporates source code from the DsTool
       program or utilities, in whole or in part, is distributed
       with a copy of that source code, including this notice. You
       must give the recipients all the rights that you have with
       respect to the use of this software. Modifications of the
       software must carry prominent notices stating who changed
       the files and the date of any change.
 
DsTool is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of FITNESS FOR A PARTICULAR PURPOSE.
The software is provided as is without any obligation on the part of Cornell 
faculty, staff or students to assist in its use, correction, modification or
enhancement.
*/

/* 
 * symbols_def.c 
 */

#ifndef SYMBOLS_DEF_HEADER
#define SYMBOLS_DEF_HEADER

#include <symbols.h>
#include <constants.h>

/* symbol and size definitions used by the print library */

int	Symbol_Codes[]={ SMALL_POINT,MED_POINT,LARGE_POINT,
			 SMALL_TRI,MED_TRI,LARGE_TRI,
			 SMALL_CROSS,MED_CROSS,LARGE_CROSS,
			 SMALL_BOX,MED_BOX,LARGE_BOX};

char	*Symbol_Labels[]={"Sm Dot","Md Dot","Lg Dot",
		      "Sm Triangle","Md Triangle","Lg Triangle",
		      "Sm Cross","Md Cross","Lg Cross",
		      "Sm Box","Md Box","Lg Box"};

int Num_Symbols = sizeof(Symbol_Codes)/sizeof(int);

/* symbol and size definitions used by the 2D graphics library */

char *Panel_Sym_Names[]={"Small Dot","Medium Dot","Large Dot",
			   "Small Cross", "Medium Cross", "Large Cross",
			   "Small Box", "Medium Box", "Large Box",
			   "Small Triangle","Medium Triangle","Large Triangle"
		       };

#endif
