/*
The DsTool program is the property of:
 
                             Cornell University 
                        Center of Applied Mathematics 
                              Ithaca, NY 14853
                      dstool_bugs@macomb.tn.cornell.edu
 
and may be used, modified and distributed freely, subject to the following
restrictions:
 
       Any product which incorporates source code from the DsTool
       program or utilities, in whole or in part, is distributed
       with a copy of that source code, including this notice. You
       must give the recipients all the rights that you have with
       respect to the use of this software. Modifications of the
       software must carry prominent notices stating who changed
       the files and the date of any change.
 
DsTool is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of FITNESS FOR A PARTICULAR PURPOSE.
The software is provided as is without any obligation on the part of Cornell 
faculty, staff or students to assist in its use, correction, modification or
enhancement.
*/

/*
 * get_cwd.c
 *
 * get_cwd returns current working directory
 *
 * The C-library procedure called may be system dependent,
 * thus we have isolated it here.
 *
 */

#include <stdlib.h>

#include <utilities.h>


/*
 * get_cwd
 *
 *  dirname must be a preallocated string
 *  size is the length of the string and must be at least one
 *    greater than the desired pathname
 */
void
get_cwd(char *dirname, int size)
{
   getcwd(dirname, size);
}
